// C Header File
// Created 8/24/2002; 12:46:57 PM

//=============================================================================
// initializes GUI (darkgray background, tiny logo, etc)
//=============================================================================
void InitGUI(void) {

char buffer[30];
char buffer2[30];
char buffer3[30];
    memset(GetPlane(LIGHT_PLANE),0xFF,LCD_SIZE);
    memset(GetPlane(DARK_PLANE),0xFF,LCD_SIZE);

DrawGrayStrExt(97+display_offsetx,1+display_offsety,(char*)NAME_VERSION_STRING,F_4x6,A_REVERSE);
DrawGrayStrExt(97+display_offsetx,8+display_offsety,(char*) AUTHOR_STRING,F_4x6,A_REVERSE);

sprintf(buffer3,"Lev %i",gamedata.level);
DrawGrayStrExt(97+display_offsetx,16+display_offsety,buffer3,F_4x6,A_REVERSE);

sprintf(buffer,"Left: %i/%i",gamedata.dot.left,gamedata.dot.count);
DrawGrayStrExt(97+display_offsetx,22+display_offsety,buffer,F_4x6,A_REVERSE);

sprintf(buffer2,"Lives: %i",gamedata.lives);
DrawGrayStrExt(127+display_offsetx,16+display_offsety,buffer2,F_4x6,A_REVERSE);
}

//Draw the Mini-Map
void DrawMinimap(FATCONFIG *fc)
{

	void *light =  GrayGetPlane(LIGHT_PLANE);
	void *dark = GrayGetPlane(DARK_PLANE);
	#define STARTX 98
	#define STARTY 28
	short x,y;
	short playerx = fc->cam_xpos>>6;
	short playery = fc->cam_ypos>>6;
	short ghostx,ghosty;
	FATSPRITE *spr=ghostspr;



char cur;
	
	#define PLAYER_IDX 0
	#define GHOST_IDX 1
	#define place_one();																												\
	 cur = (fc->map_data[y*gamedata.xsize + x]+3)*3;														\
GraySprite8_MASK(STARTX+x*3,STARTY+y*3,3,																			\
(char*)&mlevspr+cur,(char*)&mlevspr+cur+15,																		\
mask,mask,light,dark);
	
for(y=0;y<gamedata.ysize;y++)
{
for(x=0;x<gamedata.xsize;x++)
{
	place_one();
}

}
	//Draw the player
GraySprite8_AND(STARTX+playerx*3,
STARTY+playery*3,3,mask,mask,
light,dark);	
GraySprite8_OR(STARTX+playerx*3,
STARTY+playery*3,3,(char*)&mpespr+(PLAYER_IDX)*3,(char*)&mpespr+(PLAYER_IDX)*3+6,
light,dark);
		  
	//Draw the ghosts
	for(x=0;x<gamedata.cfg.ghost_count;x++)
	{
if(spr->drawmode==SPRITEMODE_UNUSED) continue;	
	ghostx = spr->xpos>>6;
	ghosty = spr->ypos>>6;
GraySprite8_AND(STARTX+ghostx*3,STARTY+ghosty*3,3,
mask,mask,light,dark);	
GraySprite8_OR(STARTX+ghostx*3,STARTY+ghosty*3,3,
(char*)&mpespr+(GHOST_IDX)*3,(char*)&mpespr+(GHOST_IDX)*3+6,
light,dark);
		++spr;
	}

}

void UpdateDotOnMinimap(FATCONFIG *fc,short x,short y)
{
short cur = (fc->map_data[y*gamedata.xsize + x]+3)*3;
GraySprite8_MASK(STARTX+x*3,STARTY+y*3,3,
(char*)&mlevspr+cur,(char*)&mlevspr+cur+15,
mask,mask,GrayGetPlane(LIGHT_PLANE),GrayGetPlane(DARK_PLANE));
}


void UpdateGhostsOnMinimap(FATCONFIG *fc)
{
short ghostx,ghosty;
short x;
FATSPRITE *spr=ghostspr;
	void *light =  GrayGetPlane(LIGHT_PLANE);
	void *dark = GrayGetPlane(DARK_PLANE);
	//Draw the ghosts
	for(x=0;x<gamedata.cfg.ghost_count;x++)
	{
if(spr->drawmode==SPRITEMODE_UNUSED) continue;	
	ghostx = spr->xpos>>6;
	ghosty = spr->ypos>>6;
GraySprite8_AND(STARTX+ghostx*3,STARTY+ghosty*3,3,
mask,mask,light,dark);	
GraySprite8_OR(STARTX+ghostx*3,STARTY+ghosty*3,3,
(char*)&mpespr+(GHOST_IDX)*3,(char*)&mpespr+(GHOST_IDX)*3+6,
light,dark);

if((gamedata.ghost[x].oldx!=ghostx)||(gamedata.ghost[x].oldy!=ghosty))
UpdateDotOnMinimap(fc,gamedata.ghost[x].oldx,gamedata.ghost[x].oldy);

		++spr;
	}	
}
void UpdatePlayerOnMinimap(FATCONFIG *fc)
{
	void *light =  GrayGetPlane(LIGHT_PLANE);
	void *dark = GrayGetPlane(DARK_PLANE);
	short playerx = fc->cam_xpos>>6;
	short playery = fc->cam_ypos>>6;	
		//Draw the player
GraySprite8_AND(STARTX+playerx*3,
STARTY+playery*3,3,mask,mask,
light,dark);	
GraySprite8_OR(STARTX+playerx*3,
STARTY+playery*3,3,(char*)&mpespr+(PLAYER_IDX)*3,(char*)&mpespr+(PLAYER_IDX)*3+6,
light,dark);

UpdateDotOnMinimap(fc,gamedata.xcamcur>>6,gamedata.ycamcur>>6);

}

typedef struct
{
	short y;
	char *text;
	short font;
} TitleStruct;

#define UpdateOptionOneText(); 				\
strcpy((char*)title[2].text+13,gamedata.cfg.gamemode?"Interactive":"Traditional");\
title[2].text[24] = ')';

#define UpdateOptionTwoText(); 				\
strcpy((char*)title[3].text+18,gamedata.cfg.fatlogo?"Yes":"No ");\
title[3].text[21] = ')';

#define UpdateOptionThreeText(); 				\
strcpy((char*)title[4].text+21,gamedata.cfg.paclogo?"Yes":"No ");\
title[4].text[24] = ')';

#define UpdateOptionFourText(); 				\
sprintf(buffer,"%02i)",gamedata.cfg.ghost_count);						\
strncpy((char*)title[5].text+15,buffer,3);

void HandleOptions(void)
{
	PADSTATES key=0;
	short a;
	char buffer[10];

TitleStruct title[]=
{
{5,		(char*)NAME_VERSION_STRING							,		F_8x10},
{18,	(char*)"GAME OPTIONS"									,		F_8x10},
{35,	(char*)"A: Gamemode (-----------)" ,		F_6x8},
{45,	(char*)"B: Show FAT logo (---)" ,		F_6x8},
{55,	(char*)"C: Show Pac 3D logo (---)" ,		F_6x8},
{65,	(char*)"D: Difficulty (--)" ,		F_6x8},
};
ClearGrayScreen();

UpdateOptionOneText();
UpdateOptionTwoText();
UpdateOptionThreeText();
UpdateOptionFourText();

for(a=0;a<(signed)(sizeof(title)/sizeof(title[0]));a++)
{
	DrawGrayStrExt(0,title[a].y,(char*)title[a].text,A_NORMAL|A_CENTERED,title[a].font);
}
key = FAT_GetPadState();

while(!(key & PADSTATE_ESC))
{
		key = FAT_GetPadState();
		if(key & PADSTATE_KA)
		{
		while(key & PADSTATE_KA) key = FAT_GetPadState();
			gamedata.cfg.gamemode++;
			if(gamedata.cfg.gamemode==2) gamedata.cfg.gamemode=0;
			UpdateOptionOneText();
			DrawGrayStrExt(0,title[2].y,(char*)title[2].text,A_REPLACE|A_CENTERED,title[2].font);
		}
		if(key & PADSTATE_KB)
		{
		while(key & PADSTATE_KB) key = FAT_GetPadState();
			gamedata.cfg.fatlogo++;
			if(gamedata.cfg.fatlogo==2) gamedata.cfg.fatlogo=0;
			UpdateOptionTwoText();
			DrawGrayStrExt(0,title[3].y,(char*)title[3].text,A_REPLACE|A_CENTERED,title[3].font);
		}		
		if(key & PADSTATE_KC)
		{
		while(key & PADSTATE_KC) key = FAT_GetPadState();
			gamedata.cfg.paclogo++;
			if(gamedata.cfg.paclogo==2) gamedata.cfg.paclogo=0;
			UpdateOptionThreeText();
			DrawGrayStrExt(0,title[4].y,(char*)title[4].text,A_REPLACE|A_CENTERED,title[4].font);
		}				
		if(key & PADSTATE_KD)
		{
		while(key & PADSTATE_KD) key = FAT_GetPadState();
			gamedata.cfg.ghost_count++;
			if(gamedata.cfg.ghost_count>GHOST_LIMIT) gamedata.cfg.ghost_count=1;
		for(a=0;a<gamedata.cfg.ghost_count;a++)
	{
		gamedata.ghost[a].adjust=0;	
		gamedata.ghost[a].oldx=0;
		gamedata.ghost[a].oldy=0;	
	}	
			UpdateOptionFourText();
			DrawGrayStrExt(0,title[5].y,(char*)title[5].text,A_REPLACE|A_CENTERED,title[5].font);

		}				

}

}

short DrawPacmanLogoAndHandleMenu(FATCONFIG *fc)
{
short a,cur_plane,b;
short location;
	short number=0;
PADSTATES key=0;
char buffer[HOWMANY*MAXLEN];
FILE *infile;
char filestr[9]={0};
TitleStruct title[]=
{
{5,		(char*)NAME_VERSION_STRING		,		F_8x10},
{18,	(char*)AUTHOR_STRING					,		F_6x8},
{30,	(char*)"Press Key A to begin",		F_6x8},
{50,	(char*)"Press APPS for Options",	F_6x8},
{70,	(char*)"Press ESC to exit"			,	F_6x8},
{94,	(char*)"http://jesystems.cjb.net",F_4x6},
};

TitleStruct levelss[]=
{
{5,		(char*)"Begin a Game!",		F_8x10},
{30,	(char*)"Press Key A for",	F_6x8},
{40,	(char*)"Internal Levels",	F_6x8},
{55,	(char*)"Press Key B for",	F_6x8},
{65,	(char*)"External Levels",	F_6x8}
};
unsigned short *p[2];

if(gamedata.cfg.paclogo)
{

ClearGrayScreen();
InvertGrayRect(0,100,239,127);
InvertGrayRect(160,0,239,99);
    
for(cur_plane=0;cur_plane<2;cur_plane++)
    {    
p[cur_plane] = GrayGetPlane(cur_plane);
}
    for(cur_plane=0;cur_plane<2;cur_plane++)
    {
location=0;
for(a=0;a<100;a++)
{
b=0;
(unsigned short)*(p[cur_plane] + a*15 + b) = pac_img_data[(cur_plane*1000) + a*10 + b];b++;
(unsigned short)*(p[cur_plane] + a*15 + b) = pac_img_data[(cur_plane*1000) + a*10 + b];b++;
(unsigned short)*(p[cur_plane] + a*15 + b) = pac_img_data[(cur_plane*1000) + a*10 + b];b++;
(unsigned short)*(p[cur_plane] + a*15 + b) = pac_img_data[(cur_plane*1000) + a*10 + b];b++;
(unsigned short)*(p[cur_plane] + a*15 + b) = pac_img_data[(cur_plane*1000) + a*10 + b];b++;
(unsigned short)*(p[cur_plane] + a*15 + b) = pac_img_data[(cur_plane*1000) + a*10 + b];b++;
(unsigned short)*(p[cur_plane] + a*15 + b) = pac_img_data[(cur_plane*1000) + a*10 + b];b++;
(unsigned short)*(p[cur_plane] + a*15 + b) = pac_img_data[(cur_plane*1000) + a*10 + b];b++;
(unsigned short)*(p[cur_plane] + a*15 + b) = pac_img_data[(cur_plane*1000) + a*10 + b];b++;
(unsigned short)*(p[cur_plane] + a*15 + b) = pac_img_data[(cur_plane*1000) + a*10 + b];b++;
}    	
    }

key = FAT_GetPadState();

while(!key)
	key = FAT_GetPadState();
	
}
menu:
ClearGrayScreen();
for(a=0;a<(signed)(sizeof(title)/sizeof(title[0]));a++)
{
	DrawGrayStrExt(0,title[a].y,(char*)title[a].text,A_NORMAL|A_CENTERED,title[a].font);
}

key = FAT_GetPadState();
while(!((key & PADSTATE_APPS) || (key & PADSTATE_KA) || (key & PADSTATE_ESC)))
	key = FAT_GetPadState();
if(key & PADSTATE_APPS)
{
	HandleOptions();
	goto menu;	
}
if(key & PADSTATE_ESC) return 1;

ClearGrayScreen();
key = FAT_GetPadState();
while(((key & PADSTATE_APPS) || (key & PADSTATE_KA) || (key & PADSTATE_ESC)))
	key = FAT_GetPadState();
for(a=0;a<(signed)(sizeof(levelss)/sizeof(levelss[0]));a++)
{
	DrawGrayStrExt(0,levelss[a].y,(char*)levelss[a].text,A_NORMAL|A_CENTERED,levelss[a].font);
}

key = FAT_GetPadState();
while(!((key & PADSTATE_KA) || (key & PADSTATE_KB)))
	key = FAT_GetPadState();

if(key & PADSTATE_KA) return 0;
if(key & PADSTATE_KB)
{
	number = findAllFilesSet(buffer, "pmlv", HOWMANY);
	if (!number) return 0;
	number = domenu(35, 28, buffer, number, 0);
	if(number == -1) return 0;
	strcpy(filestr,buffer+number*MAXLEN);
	infile = fopen(filestr,"rb");

if(infile)
{
fread(&gamedata.xsize,sizeof(short),1,infile);
fread(&gamedata.ysize,sizeof(short),1,infile);
ext_level_data = malloc(gamedata.xsize*gamedata.ysize*sizeof(char));
if(ext_level_data!=NULL)
fread(ext_level_data,sizeof(char),gamedata.xsize*gamedata.ysize,infile);
		fclose(infile);
		}
	}

if(ext_level_data!=NULL)
fc->map_data = ext_level_data;
return 0;

}


void ShowCongratulationsScreen(void)
{
	PADSTATES key = 0;
	short a;
	TitleStruct congrats[]=
{
{5,		(char*)"Congratulations!",		F_8x10},
{40,	(char*)"You finished.",	F_8x10},
{60,	(char*)"Press a key to continue.",	F_6x8}
};
	ClearGrayScreen();
	for(a=0;a<(signed)(sizeof(congrats)/sizeof(congrats[0]));a++)
{
	DrawGrayStrExt(0,congrats[a].y,(char*)congrats[a].text,A_NORMAL|A_CENTERED,congrats[a].font);
}
key = FAT_GetPadState();

while(!key)
	key = FAT_GetPadState();
	
}
